def fact(n):
    """Factorial of n.
fact(n) => n!
fact(6) => 720"""
    if n == 0:
        return 1
    result = 1
    for i in range(1, n+1): result *= i
    return result

def perm(n, r):
    """Permutations (selection of r objects from a group of n objects where the
order is important).
perm(n, r) => nPr
perm(12, 4) => 11880"""
    return fact(n)/fact(n-r)

def comb(n, r):
    """Combinations (selection of r objects from a group of n objects where the
order is not important).
comb(n, r) => nCr
comb(52, 5) => 2598960"""
    return fact(n)/(fact(n-r)*fact(r))

def expand(a, b, n):
    """Expands a binomial in 2 steps.
a is coefficient of first term.
b is coefficient of second term.
n is exponent of binomial."""
    for i in range(n+1):
        print "%s x^%s y^%s" % (comb(n, i), n-i, i),
        if i != n:
            print '+',
    print
    for i in range(n+1):
        print comb(n, i)*(a**(n-i))*(b**i),
        if i != n:
            print '+',
    print
